/* Tabela PARAMESTOQUE: Parmetro do Estoque(Geral) */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PARAMESTOQUE */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Parmetro do Estoque(Geral),
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_EST_PARAMESTOQUE
AFTER DELETE OR INSERT OR UPDATE
ON PARAMESTOQUE FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(300);
  V_DTOPER    DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.IDTRATAVENC IS NOT NULL THEN
         V_DESC := V_DESC || 'TratVenc=' || :OLD.IDTRATAVENC;
      END IF;

      IF :OLD.VRPETOLEENTR IS NOT NULL THEN
         V_DESC := V_DESC || ' ToleEnt=' || :OLD.VRPETOLEENTR;
      END IF;

      IF :OLD.IDLANCDTMEN IS NOT NULL THEN
         V_DESC := V_DESC || ' LDtMen=' || :OLD.IDLANCDTMEN;
      END IF;

      IF :OLD.NRDIASENTR IS NOT NULL THEN
         V_DESC := V_DESC || ' DiaEntr=' || :OLD.NRDIASENTR;
      END IF;

      IF :OLD.NRDIASSAID IS NOT NULL THEN
         V_DESC := V_DESC || ' DiaSaid=' || :OLD.NRDIASSAID;
      END IF;

      IF :OLD.NRDIASAJUS IS NOT NULL THEN
         V_DESC := V_DESC || ' DiaAjus=' || :OLD.NRDIASAJUS;
      END IF;

      IF :OLD.IDLANCDTMAI IS NOT NULL THEN
         V_DESC := V_DESC || ' LanDtMai=' || :OLD.IDLANCDTMAI;
      END IF;

      IF :OLD.NRDIASENTRPD IS NOT NULL THEN
         V_DESC := V_DESC || ' DEntrPos=' || :OLD.NRDIASENTRPD;
      END IF;

      IF :OLD.NRDIASSAIDPD IS NOT NULL THEN
         V_DESC := V_DESC || ' DSaidPos=' || :OLD.NRDIASSAIDPD;
      END IF;

      IF :OLD.NRDIASAJUSPD IS NOT NULL THEN
         V_DESC := V_DESC || ' DAjusPos=' || :OLD.NRDIASAJUSPD;
      END IF;

      IF :OLD.CDGROPERRETI IS NOT NULL THEN
         V_DESC := V_DESC || ' AutAltRet=' || :OLD.CDGROPERRETI;
      END IF;

      IF :OLD.CDGROPERFMES IS NOT NULL THEN
         V_DESC := V_DESC || ' AutLMF=' || :OLD.CDGROPERFMES;
      END IF;

      IF :OLD.CDGROPERSOLI IS NOT NULL THEN
         V_DESC := V_DESC || ' AutBPSC=' || :OLD.CDGROPERSOLI;
      END IF;

      IF :OLD.CDGROPERREQ IS NOT NULL THEN
         V_DESC := V_DESC || ' AutAltRE=' || :OLD.CDGROPERREQ;
      END IF;

      IF :OLD.IDCONSFORNFJ IS NOT NULL THEN
         V_DESC := V_DESC || ' PerCCFL=' || :OLD.IDCONSFORNFJ;
      END IF;

      IF :OLD.IDALTDTFECDIA IS NOT NULL THEN
         V_DESC := V_DESC || ' AltProxDP=' || :OLD.IDALTDTFECDIA;
      END IF;

      IF :OLD.IDGTGTXTFDIA IS NOT NULL THEN
         V_DESC := V_DESC || ' GeraTGFD=' || :OLD.IDGTGTXTFDIA;
      END IF;

      IF :OLD.IDBLOQFORIRR IS NOT NULL THEN
         V_DESC := V_DESC || ' IdBloqForIrr=' || :OLD.IDBLOQFORIRR;
      END IF;

      IF :OLD.NRDIASMOVESTCEG IS NOT NULL THEN
         V_DESC := V_DESC || ' NrDiasMovEstCego=' || :OLD.NRDIASMOVESTCEG;
      END IF;      

      IF :OLD.CDGROPERLOT IS NOT NULL THEN
         V_DESC := V_DESC || ' AutAltLot=' || :OLD.CDGROPERLOT;
      END IF;

      IF :OLD.IDPERINATPRRELAC IS NOT NULL THEN
         V_DESC := V_DESC || ' PermInatProdComp=' || :OLD.IDPERINATPRRELAC;
      END IF;

      V_TIPO := '3';
      V_ITPESQ := :OLD.CDPARESTOQ;
   ELSE
      IF UPDATING THEN
         IF (:OLD.IDTRATAVENC   <> :NEW.IDTRATAVENC)   OR
            (:OLD.VRPETOLEENTR  <> :NEW.VRPETOLEENTR)  OR
            (:OLD.IDLANCDTMEN   <> :NEW.IDLANCDTMEN)   OR
            (:OLD.NRDIASENTR    <> :NEW.NRDIASENTR)    OR
            (:OLD.NRDIASSAID    <> :NEW.NRDIASSAID)    OR
            (:OLD.NRDIASAJUS    <> :NEW.NRDIASAJUS)    OR
            (:OLD.IDLANCDTMAI   <> :NEW.IDLANCDTMAI)   OR
            (:OLD.NRDIASENTRPD  <> :NEW.NRDIASENTRPD)  OR
            (:OLD.NRDIASSAIDPD  <> :NEW.NRDIASSAIDPD)  OR
            (:OLD.NRDIASAJUSPD  <> :NEW.NRDIASAJUSPD)  OR
            (NVL(:OLD.CDGROPERRETI, 'NULO') <> NVL(:NEW.CDGROPERRETI, 'NULO'))  OR
            (NVL(:OLD.CDGROPERFMES, 'NULO') <> NVL(:NEW.CDGROPERFMES, 'NULO'))  OR
            (NVL(:OLD.CDGROPERSOLI, 'NULO') <> NVL(:NEW.CDGROPERSOLI, 'NULO'))  OR
            (NVL(:OLD.CDGROPERREQ, 'NULO')  <> NVL(:NEW.CDGROPERREQ, 'NULO'))   OR
            (NVL(:OLD.CDGROPERLOT, 'NULO')  <> NVL(:NEW.CDGROPERLOT, 'NULO'))   OR
            (:OLD.IDCONSFORNFJ  <> :NEW.IDCONSFORNFJ)  OR
            (:OLD.IDALTDTFECDIA <> :NEW.IDALTDTFECDIA) OR
            (:OLD.IDGTGTXTFDIA  <> :NEW.IDGTGTXTFDIA)  OR
            (:OLD.IDBLOQFORIRR  <> :NEW.IDBLOQFORIRR)  OR
            (:OLD.IDPERINATPRRELAC <> :NEW.IDPERINATPRRELAC)  OR            
            (NVL(:OLD.NRDIASMOVESTCEG, 0) <> NVL(:NEW.NRDIASMOVESTCEG, 0)) THEN

            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDPARESTOQ;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDPARESTOQ;
      END IF;

      IF NVL(:OLD.IDTRATAVENC, '') <> NVL(:NEW.IDTRATAVENC, '') THEN
         V_DESC := V_DESC || 'TraVenc=' || :NEW.IDTRATAVENC;
      END IF;

      IF NVL(:OLD.VRPETOLEENTR, '') <> NVL(:NEW.VRPETOLEENTR, '') THEN
         V_DESC := V_DESC || ' TolEnt=' || :NEW.VRPETOLEENTR;
      END IF;

      IF NVL(:OLD.IDLANCDTMEN, '') <> NVL(:NEW.IDLANCDTMEN, '') THEN
         V_DESC := V_DESC || ' LDtMen=' || :NEW.IDLANCDTMEN;
      END IF;

      IF NVL(:OLD.NRDIASENTR, '') <> NVL(:NEW.NRDIASENTR, '') THEN
         V_DESC := V_DESC || ' DiaEnt=' || :NEW.NRDIASENTR;
      END IF;

      IF NVL(:OLD.NRDIASSAID, '') <> NVL(:NEW.NRDIASSAID, '') THEN
         V_DESC := V_DESC || ' DiaSai=' || :NEW.NRDIASSAID;
      END IF;

      IF NVL(:OLD.NRDIASAJUS, '') <> NVL(:NEW.NRDIASAJUS, '') THEN
         V_DESC := V_DESC || ' DiaAju=' || :NEW.NRDIASAJUS;
      END IF;

      IF NVL(:OLD.IDLANCDTMAI, '') <> NVL(:NEW.IDLANCDTMAI, '') THEN
         V_DESC := V_DESC || ' LDtMai=' || :NEW.IDLANCDTMAI;
      END IF;

      IF NVL(:OLD.NRDIASENTRPD, '') <> NVL(:NEW.NRDIASENTRPD, '') THEN
         V_DESC := V_DESC || ' EntPos=' || :NEW.NRDIASENTRPD;
      END IF;

      IF NVL(:OLD.NRDIASSAIDPD, '') <> NVL(:NEW.NRDIASSAIDPD, '') THEN
         V_DESC := V_DESC || ' SaiPos=' || :NEW.NRDIASSAIDPD;
      END IF;

      IF NVL(:OLD.NRDIASAJUSPD, '') <> NVL(:NEW.NRDIASAJUSPD, '') THEN
         V_DESC := V_DESC || ' AjuPos=' || :NEW.NRDIASAJUSPD;
      END IF;

      IF NVL(:OLD.CDGROPERRETI, 'NULO') <> NVL(:NEW.CDGROPERRETI, 'NULO') THEN
         V_DESC := V_DESC || ' AutAltRet=' || NVL(:NEW.CDGROPERRETI, 'NULO');
      END IF;

      IF NVL(:OLD.CDGROPERFMES, 'NULO') <> NVL(:NEW.CDGROPERFMES, 'NULO') THEN
         V_DESC := V_DESC || ' AutLMF=' || NVL(:NEW.CDGROPERFMES, 'NULO');
      END IF;

      IF NVL(:OLD.CDGROPERSOLI, 'NULO') <> NVL(:NEW.CDGROPERSOLI, 'NULO') THEN
         V_DESC := V_DESC || ' AutBPSC=' || NVL(:NEW.CDGROPERSOLI, 'NULO');
      END IF;

      IF NVL(:OLD.CDGROPERREQ, 'NULO') <> NVL(:NEW.CDGROPERREQ, 'NULO') THEN
         V_DESC := V_DESC || ' AutAltRE=' || NVL(:NEW.CDGROPERREQ, 'NULO');
      END IF;

      IF NVL(:OLD.IDCONSFORNFJ, '') <> NVL(:NEW.IDCONSFORNFJ, '') THEN
         V_DESC := V_DESC || ' PerCCFL=' || :NEW.IDCONSFORNFJ;
      END IF;

      IF NVL(:OLD.IDALTDTFECDIA, '') <> NVL(:NEW.IDALTDTFECDIA, '') THEN
         V_DESC := V_DESC || ' AltProxDP=' || :NEW.IDALTDTFECDIA;
      END IF;

      IF NVL(:OLD.IDGTGTXTFDIA, '') <> NVL(:NEW.IDGTGTXTFDIA, '') THEN
         V_DESC := V_DESC || ' GeraTGFD=' || :NEW.IDGTGTXTFDIA;
      END IF;

      IF NVL(:OLD.IDBLOQFORIRR, '') <> NVL(:NEW.IDBLOQFORIRR, '') THEN
         V_DESC := V_DESC || ' IdBloqForIrr=' || :NEW.IDBLOQFORIRR;
      END IF;

      IF NVL(:OLD.NRDIASMOVESTCEG, 0) <> NVL(:NEW.NRDIASMOVESTCEG, 0) THEN
         V_DESC := V_DESC || ' NrDiasMovEstCego=' || :NEW.NRDIASMOVESTCEG;
      END IF;

      IF NVL(:OLD.CDGROPERLOT, 'NULO') <> NVL(:NEW.CDGROPERLOT, 'NULO') THEN
         V_DESC := V_DESC || ' AutAltLot=' || NVL(:NEW.CDGROPERLOT, 'NULO');
      END IF;

      IF NVL(:OLD.IDPERINATPRRELAC, '') <> NVL(:NEW.IDPERINATPRRELAC, '') THEN
         V_DESC := V_DESC || ' PermInatProdComp=' || NVL(:NEW.IDPERINATPRRELAC, '');
      END IF;
   END IF;

   IF (V_TIPO <> '0')  THEN
      IF NOT V_DESC IS NULL THEN
         NMUSUARIO(V_USUARIO);
         WEBTUNNING(V_DSREMOTEADDR,
                    V_DSREMOTEHOST,
                    V_DSSERVERRDM,
                    V_DSSERVMETHOD,
                    V_DSREMOTEOPER);

         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('PARAMESTOQUE',  V_DTOPER, V_USUARIO,
                V_TIPO,         V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_EST_PARAMESTOQUE','6.19.xxx'); END;
/

